init()
{
	level thread onPlayerConnect();
}

onPlayerConnect()
{
	for(;;)
	{
		level waittill("connected", player);
		if(level.ex_selfheal)
		{
			player thread onPlayerSpawned();
			player thread onPlayerKilled();
		}
	}
}

onPlayerSpawned()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("spawned_player");
		self thread monitorFirstAid();
	}
}

onPlayerKilled()
{
	self endon("disconnect");
	
	for(;;)
	{
		self waittill("killed_player");
		if(isDefined(self.ex_firstaidval)) self.ex_firstaidval destroy();
		self.ex_firstaidkits = level.ex_firstaidkits;
		if(isDefined(self.ex_firstaidicon)) self.ex_firstaidicon destroy();
	}
}

monitorFirstAid()
{
	level endon("game_ended");
	self endon("disconnect");
	self endon("spawned");
	self endon("death");	

	if (!level.ex_selfheal) return;

	if(level.inPrematchPeriod)
		level waittill("prematch_over");

	if (!isDefined(self.ex_firstaidkits ))
		self.ex_firstaidkits = level.ex_firstaidkits ;

	if(!isDefined(self.ex_firstaidicon))
	{
		self.ex_firstaidicon = newClientHudElem(self);			
		self.ex_firstaidicon.alignX = "center";
		self.ex_firstaidicon.alignY = "middle";
		self.ex_firstaidicon.horzAlign = "fullscreen";
		self.ex_firstaidicon.vertAlign = "fullscreen";
		self.ex_firstaidicon.alpha = 0.5;
		self.ex_firstaidicon.x = 616;
		self.ex_firstaidicon.y = 416;
		self.ex_firstaidicon.color = (0,1,0);
		self.ex_firstaidicon setShader("hint_health", 16, 16);		
	}

	
	if(!isDefined(self.ex_firstaidval))
	{
		self.ex_firstaidval = newClientHudElem(self);
		self.ex_firstaidval.fontScale = 1.4;
		self.ex_firstaidval.alignX = "center";
		self.ex_firstaidval.alignY = "middle";
		self.ex_firstaidval.horzAlign = "fullscreen";
		self.ex_firstaidval.vertAlign = "fullscreen";
		self.ex_firstaidval.alpha = 0.5;
		self.ex_firstaidval.x = 630;
		self.ex_firstaidval.y = 416;
			
		if(self.ex_firstaidkits> 0) self.ex_firstaidval.color = (1, 1, 1);
			else self.ex_firstaidval.color = (1, 0, 0);
			
		self.ex_firstaidval setValue(self.ex_firstaidkits);
	}

	while (isAlive(self) && self.sessionstate == "playing")
	{
		healamount = (level.ex_minheal + randomInt(level.ex_maxheal - level.ex_minheal));
		healtime = int(healamount / 2) * .1;

		targetplayer =  Target_Player();

		while(self useButtonPressed() && targetplayer.health < level.ex_fullhealth && self.ex_firstaidkits > 0)
		{
			// wait 2 seconds (make sure they mean it, are holding USE)
			holdtime = 0;

			while(isPlayer(self) && self useButtonPressed() && holdtime < 2)
			{
				holdtime += 0.05;
				wait (0.05 * level.fps_multiplier);
			}

			if(holdtime < 2) break;
			
			// can't heal while moving
			if (extreme\_ex_utils::isMoving(self)) break;

			if ((level.gametype == "sd" || level.gametype == "sab") && self.isPlanting)
				break;
			
			// fade counter
			if(isDefined(self.ex_firstaidval))
			{
				self.ex_firstaidval fadeOverTime(1);
				self.ex_firstaidval.alpha = 0;	
			}

			if(isDefined(self.ex_firstaidicon))
				self.ex_firstaidicon scaleOverTime(healtime, 32, 32);

			Heal(targetplayer);
			self enableWeapons();

			if(isDefined(self.ex_firstaidicon))
				self.ex_firstaidicon scaleOverTime(healtime, 16, 16);

			self.ex_firstaidkits--;
			if (self.ex_firstaidkits < 0) self.ex_firstaidkits = 0; 

			healamount--;
			
			wait (.5 * level.fps_multiplier);
		}

		if(isDefined(self.ex_firstaidval))
		{
			if(self.ex_firstaidkits > 0) self.ex_firstaidval.color = (1, 1, 1);
				else self.ex_firstaidval.color = (1, 0, 0);

			self.ex_firstaidval setValue(self.ex_firstaidkits);
			self.ex_firstaidicon.alpha = 0.8;
		}

		// fadein counter
		if(isDefined(self.ex_firstaidval))
		{
			self.ex_firstaidval fadeOverTime(1);
			self.ex_firstaidval.alpha = 1;
		}

		wait (.5 * level.fps_multiplier);
	}
}

Heal(targetplayer)
{
	if (targetplayer == self)
	{
		iprintln (&"FIRSTAID_ISUSING", targetplayer.name );
		self disableWeapons();
	}
	else
	{
		iprintln (&"FIRSTAID_FIXEDUP", targetplayer.name, self.name );
		self disableWeapons();
	}

	targetplayer playSound("health_pickup_medium"); 

 	healamount = (level.ex_minheal + randomInt(level.ex_maxheal - level.ex_minheal));
	health = healamount;
	for(i = 0;i < health ;i++) 
	{
		if(isdefined(targetplayer))
		{
			if(targetplayer.health < level.ex_fullhealth)
			{
				targetplayer.health += 1;
			}
			else
			{
				targetplayer.health = level.ex_fullhealth;
				break;
			}
		}
		else break;

		wait ( 0.05 * level.fps_multiplier);
	}

	if(!isdefined(targetplayer))
		targetplayer = self;
	
	if (isAlive(targetplayer))
	{
		if (targetplayer.health >= level.ex_fullhealth)
		{
			targetplayer iprintln (  &"FIRSTAID_MAXHEALTH");
		}
		else		
		{
			targetplayer iprintln (  &"FIRSTAID_HEALINGFINISHED");
		}
	}

	if (isdefined(self) && targetplayer != self)
		self.score = self.score +1;

	return targetplayer;
}

Target_Player()
{
	self_targetplayer = self;
	
	players = level.players;
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		if (player == self) continue;
		if (player.health == level.ex_fullhealth || !isAlive(player) || player.pers["team"] != self.pers["team"]) continue;
		if ( distance(player.origin, self.origin) > 31) continue;

		self_targetplayer = player;

		break;
	}

	return self_targetplayer;
}
