#include maps\mp\_utility;

//*********************************************************************************************
// extreme launch main threads
//*********************************************************************************************
main()
{
	if(getDvar("ex_maprotdone") == "")
	//{
		//if(level.ex_pbrotate)
			//extreme\_ex_maprotation::pbrotation();
		setDvar("ex_maprotdone","1");
	//}
	
	// fix the map rotation
	if(level.ex_fixmaprotation) level extreme\_ex_maprotation::fixMapRotation();
	
	// set a random map rotation
	if(level.ex_randommaprotation) level thread extreme\_ex_maprotation::randomMapRotation();
	
	// clear any camping players
	if(level.ex_campwarntime || level.ex_campsniper_warntime) thread extreme\_ex_camper::removeCampers();
	
	// healthbar
	if(level.ex_healthbar) self thread extreme\_ex_healthbar::init();

	// firstaid
	if(level.ex_selfheal) self thread extreme\_ex_firstaid::init();

	// spawn protection
	if(level.ex_spawnprotection) self thread extreme\_ex_spawnpro::init();

	// server messages
	if(level.ex_svrmsg) level thread extreme\_ex_messages::serverMessages();

	// livestats
	if(level.ex_livestats) level thread extreme\_ex_livestats::init();
	
	// Turrets
	if(!level.ex_allow_turrets) level thread extreme\_ex_turret::removeTurrets();
	
	// text logos for mod and server
	thread extreme\_ex_modinfo::main();
	
	// launch name checker
	if(level.ex_namechecker) level thread extreme\_ex_namecheck::init();
	
	// time announcer
	if(level.ex_timeannouncer) level thread extreme\_ex_timeannouncer::main();
	
	// rotate if empty
	if(level.ex_rotateifempty) level thread extreme\_ex_rotate::main();
	
	// start player bob factor
	if(level.ex_bobfactor) self thread extreme\_ex_bobfactor::playerBobFactor();
}

//*********************************************************************************************
// extreme launch player threads
//*********************************************************************************************
playerThreads()
{
	level endon("game_ended");
	self endon("disconnect");
	self endon("killed_player");

	// show logo
	if(level.ex_logo_image) self thread extreme\_ex_logo::init();
	
	// show MOD logo
	//if(level.ex_modlogo) self thread extreme\_ex_logo::mod_logo();

	// apply laser dot
	if(level.ex_laserdot) self createLaserdot();

	// laserdot delete while ADS
	self thread laserDotAds();

	// show welcome messages 
	self thread handleWelcome();
         
	// Positioning shows you your exact position on a map (in devmap mode only)
	//self thread extreme\_ex_tools::ShowPlayerPosition();
	
	//rangefinder
	if(level.ex_rangefinder) self thread extreme\_ex_rangefinder::main();
	
	// camper check
	if(level.ex_campwarntime || level.ex_campsniper_warntime) self thread extreme\_ex_camper::campercheck();

}

exPreSpawn()
{
	//if(level.ex_rangefinder) self thread extreme\_ex_rangefinder::main(); 
	
	level endon("ex_gameover");
	self endon("disconnect");

	// set spawn variables
	setPlayerVariables();
	
	// remove camper objective
	if(level.ex_campwarntime || level.ex_campsniper_warntime) self thread extreme\_ex_camper::removeCamper();
}

exPostSpawn()
{
	level endon("game_ended");
	self endon("disconnect");
	self notify("spawned");

	// wait for threads to die
	//wait 0.05;

	if(isPlayer(self))
	{
		self thread playerThreads();
	}
}

exPlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{
	self endon("disconnect");
	self notify("killed_player");

	if(self.sessionteam == "spectator")
		return;

	switch(sMeansOfDeath)
	{
		case "MOD_MELEE":
			break;
		case "MOD_PROJECTILE":
		case "MOD_PROJECTILE_SPLASH":
		case "MOD_GRENADE_SPLASH":
		case "MOD_EXPLOSIVE":
			break;
		default:
			break;
	}
	
	if(level.ex_fbannounce && !isDefined(self.switching_teams))
	{
		players = getentarray("player", "classname"); //players = level.players;
		if(level.ex_firstblood && isplayer(attacker))
		{
			for(i=0;i < players.size;i++)
			{
				if(players[i] != self)
				{
					players[i] thread maps\mp\gametypes\_hud_message::oldNotifyMessage(&"FIRSTBLOOD_REPORT_ALL", attacker.name);
					if(attacker.pers["team"] != self.pers["team"] || !level.ex_teamplay)  players[i] iprintlnbold(&"FIRSTBLOOD_VICTIM", self.name);
					else if(attacker.pers["team"] == self.pers["team"] && level.ex_teamplay && attacker != self) players[i] iprintlnbold(&"FIRSTBLOOD_VICTIM_TEAM_MATE", self.name);
					else if(attacker == self) players[i] iprintlnbold(&"FIRSTBLOOD_VICTIM_SELF");
				
				}	
				players[i] playlocalsound("firstblood");
			}
			self thread maps\mp\gametypes\_hud_message::oldNotifyMessage(&"FIRSTBLOOD_REPORT_SELF");
			self playlocalsound("whyami");
		}
		level.ex_fbannounce = false;
	}

	// dropping medikits
	if(level.ex_drophealth) self extreme\_ex_medkits::healthDrop();
	
	// clean the hud
	self extreme\_ex_hud::cleanplayer();
}

exEndMap()
{
	// clear hud elements
	level thread extreme\_ex_hud::cleanallhud();
}

//************************************************************************************************************************************************************************
// extreme player additional routines
//************************************************************************************************************************************************************************
handleWelcome()
{
	level endon("ex_gameover");
	level endon("game_ended");
	self endon("disconnect");

	if(isPlayer(self)) self thread extreme\_ex_messages::welcomemsg();
}

createLaserdot()
{
	level endon("game_ended");
	self endon("disconnect");
	self endon("killed_player");

	if(level.inPrematchPeriod)
	level waittill("prematch_over");

	if (level.ex_laserdot)
	{ 
		if(!isdefined(self.ex_laserdot))
		{
			self.ex_laserdot = newClientHudElem(self);
			self.ex_laserdot.x = 321;
			self.ex_laserdot.y = 241;
			self.ex_laserdot.alignX = "center";
			self.ex_laserdot.alignY = "middle";
			self.ex_laserdot.alpha = 1;
			self.ex_laserdot.archived = false;
			self.ex_laserdot setShader("compassping_enemyfiring", 10, 10);
      	}
	}
}

laserDotAds()
{
	self endon("spawned");
	self endon("killed_player");

   	while (isAlive(self) && self.sessionstate == "playing")
	{
		// Wait
		wait (.05 * level.fps_multiplier);

		if(isdefined(self.ex_laserdot))
		{
			if(self playerADS() == 1)
			self.ex_laserdot.alpha = 0;
			else
 			self.ex_laserdot.alpha = level.ex_laserdot;
		}
	}
}

WeaponDamageMod( eVictim, eAttacker, iDamage, sMeansOfDeath, sWeapon, sHitLoc )
{
	if (level.ex_wdmodon && sWeapon != "none" && sMeansOfDeath != "MOD_MELEE")
	{
		weapondvar = "";
		if (isDefined(game["ex_wdm"][sWeapon]))
			weapondvar = game["ex_wdm"][sWeapon];
		
		if (weapondvar != "")
		{
			if (getdvar(weapondvar) != "" && getdvarfloat(weapondvar) > 0)
			{
				multiplier = getdvarfloat(weapondvar);
				iDamage = int((iDamage / 100) * multiplier);
			}
		}
	}

	return iDamage;
}

setPlayerVariables()
{
	self thread resetFlagVars();

	count = 1;

	// misc variables
	if(!isDefined(game[self.name])) game[self.name] = [];
	if(!isDefined(game[self.name]["conseckill"])) game[self.name]["conseckill"] = 0;

	// set streak variables to 0
	self.pers["noobstreak"] = 0;
	self.pers["weaponstreak"] = 0;
	self.pers["weaponname"] = "";
	self.pers["conseckill"] = 0;
}

resetPlayerVariables()
{
	self thread resetFlagVars();

	//count = 0;

	// misc variables
	self.pers["weaponname"] = "";

	if(isDefined(game[self.name])) game[self.name] = [];
	game[self.name]["conseckill"] = 0;

	self.score = 0;
	self.deaths = 0;

	// reset all weapons and firstaid
	//self thread extreme\_ex_weapons::replenishWeapons(true);
	//self thread extreme\_ex_weapons::replenishGrenades(true);
	//self thread extreme\_ex_weapons::replenishFirstaid(true);	
}

resetFlagVars()
{
	// eXtreme+
	self.ex_iscamper = false;
	self.ex_inmenu = false;
	if(!isDefined(self.ex_isunknown)) self.ex_isunknown = false;
	if(!isDefined(self.ex_isdupname)) self.ex_isdupname = false;
	self.ex_invulnerable = false;
	self.ex_ishealing = undefined;
	self.ex_bleeding = false;
	self.ex_firstaidkits = level.ex_firstaidkits;
	self.ex_bsoundinit = false;
	self.ex_spwn_punish = undefined;
	self.spamdelay = undefined;
}

handleDupName()
{
	level endon("ex_gameover");
	self endon("disconnect");
	self endon("ex_dead");
	self endon("ex_freefall");

	// Tag the player to prevent the Name Checker to kick in more than once
	self.ex_isdupname = true;

	iprintlnbold(&"NAMECHECK_DNCHECK_DUPNAME1", self);
	self setClientDvar("name", "Unknown Soldier");
	self iprintlnbold(&"NAMECHECK_DNCHECK_NEWUNKNOWN");

	if(level.ex_ncskipwarning)
	{
		if(level.ex_usclanguest) self iprintlnbold(&"NAMECHECK_DNCHECK_NEXTCLANGUEST");
			else self iprintlnbold(&"NAMECHECK_DNCHECK_NEXTGUEST");
	}
	else self iprintlnbold(&"NAMECHECK_DNCHECK_NEXTUNKNOWN");

	// Wait several seconds before starting the Unknown Soldier handling code
	wait 10;
	self thread handleUnknown(level.ex_ncskipwarning);

	// Remove the tag; the player is officially an Unknown Soldier now
	self.ex_isdupname = false;
}

handleUnknown(skipwarning)
{
	level endon("ex_gameover");
	self endon("disconnect");
	self endon("ex_dead");
	self endon("ex_freefall");

	// Tag the player to prevent the Name Checker to kick in more than once
	self.ex_isunknown = true;

	usname = [];

	if(!skipwarning)
	{
		if(isPlayer(self))
		{
			// Warn them first
			if(level.ex_usclanguest)
			{
				iprintlnbold(&"UNKNOWNSOLDIER_MSG_UNACCEPTABLE", self);
				self iprintlnbold(&"UNKNOWNSOLDIER_MSG_CHANGEIT");
				self iprintlnbold(&"UNKNOWNSOLDIER_MSG_CLANGUEST", level.ex_uswarndelay1);
			}
			else
			{
				iprintlnbold(&"UNKNOWNSOLDIER_MSG_UNACCEPTABLE", self);
				self iprintlnbold(&"UNKNOWNSOLDIER_MSG_CHANGEIT");
				self iprintlnbold(&"UNKNOWNSOLDIER_MSG_GUEST", level.ex_uswarndelay1);
			}
		}
		// Now give them some time to change their name
		waitWhileUnknown(level.ex_uswarndelay1);
	}

	if(isPlayer(self) && isUnknown(self))
	{
		// Get a free guest number (1 to sv_maxclients)
		level.ex_usguestno = getFreeGuestSlot();

		if(level.ex_usclanguest)
		{
			usname[0] = level.ex_usclanguestname; // Clan Guest
			usname[1] = usname[0] + level.ex_usguestno;
			self setClientDvar("name", usname[1]);
			self iprintlnbold(&"UNKNOWNSOLDIER_NEWNAME_BYSERVER");
			self iprintlnbold(&"UNKNOWNSOLDIER_NEWNAME_CLANGUEST", usname[1]);

			// Clan guests are now off the hook; show welcome messages and return
			self.ex_isunknown = false;
			wait 3;
			if(isPlayer(self)) self thread extreme\_ex_messages::welcomemsg();
			return;
		}
		else
		{
			// Only assign guest name if not already using an assigned guest name
			if(!isAssignedName(self))
			{
				usname[0] = level.ex_usguestname; // Non-clan Guest
				usname[1] = usname[0] + level.ex_usguestno;
				self setClientDvar("name", usname[1]);
				self iprintlnbold(&"UNKNOWNSOLDIER_NEWNAME_BYSERVER");
				self iprintlnbold(&"UNKNOWNSOLDIER_NEWNAME_GUEST", usname[1]);
				self iprintlnbold(&"UNKNOWNSOLDIER_NEWNAME_CHANGEIT", level.ex_uswarndelay2);

				// After name assignment, non-clan guests get a second chance to change their name
				waitWhileUnknown(level.ex_uswarndelay2);
			}
		}
	}

	if(isPlayer(self) && isUnknown(self))
	{
		// My god, don't they understand? ok, time to f*** around with them!
		count = 0;
		while(isPlayer(self) && isUnknown(self) && count < level.ex_uspunishcount)
		{
			if(!self.ex_sinbin)
			{
				while(self.ex_sinbin) wait 1;
				iprintlnbold(&"UNKNOWNSOLDIER_MSG_TEMPORARY", self);
				self iprintlnbold(&"UNKNOWNSOLDIER_MSG_CHANGEIT");
				self iprintlnbold(&"UNKNOWNSOLDIER_STILL_PUNISH");
				//self thread extreme\_ex_utils::punishment("drop", "freeze");
				//self disableWeapons;
				waitWhileUnknown(10);
				//if(isPlayer(self)) //self thread extreme\_ex_utils::punishment("enable", "release");
				waitWhileUnknown(20 + randomInt(20));
				count++;
			}
			else break;
		}

		// Now, if still using assigned name, allow them to play without punishment until they die
		if(isPlayer(self) && isAssignedName(self))
		{
			// Set punished-tag so Name Checker doesn't kick in again
			self.ex_ispunished = true;
			self iprintlnbold(&"UNKNOWNSOLDIER_STILL_RELIEF1");
			self iprintlnbold(&"UNKNOWNSOLDIER_STILL_RELIEF2");
			self iprintlnbold(&"UNKNOWNSOLDIER_MSG_CHANGEIT");
		}
	}

	// Allow the Name Checker to iterate once to catch duplicate names.
	// Keep this wait statement outside the following if-block to catch players
	// that would otherwise fall through by quickly changing their name from US
	// to a valid name and back to US again (highly unlikely, but possible with key bindings)
	wait 5;

	if(isPlayer(self) && !self.ex_ispunished && !isUnknown(self))
	{
		// Has the Name Checker tagged him because of using a duplicate name?
		if(isPlayer(self) && !self.ex_isdupname)
		{
			// No, so thank them, and show the welcome messages
			iprintlnbold(&"UNKNOWNSOLDIER_MSG_THANKS", self);
			wait 3;
			if(isPlayer(self)) self thread extreme\_ex_messages::welcomemsg();
		}
		else self thread handleDupName();
	}

	// Remove the tag; the player is either renamed, punished or dupname-tagged
	self.ex_isunknown = false;
}

waitWhileUnknown(seconds)
{
	// Wait for x seconds as long as player has unacceptable name
	for(i = 0; i < seconds; i++)
	{
		if(isPlayer(self) && !isUnknown(self)) return;
			else wait 1;
	}
}

isUnknownSoldier(player)
{
	// Check if player is Unknown Soldier
	// Color codes are removed. Name is lowercased, so it will reject any case combination

	self endon("disconnect");
	self endon("ex_dead");

	playernorm = "";
	if(isPlayer(player)) playernorm = extreme\_ex_utils::monotone(player.name);
	//playernorm = extreme\_ex_utils::lowercase(playernorm);

	if(playernorm == "" || playernorm == "unknown soldier" || playernorm == "unknownsoldier") return true;
	return false;
}

isAssignedName(player)
{
	// Check if player has an assigned guest name
	// Do NOT check for assigned clan guest names!

	self endon("disconnect");
	self endon("ex_dead");

	chkname = [];
	maxguestno = getDvarInt("sv_maxclients");
	chkname[0] = level.ex_usguestname;

	for(i = 1; i <= maxguestno; i++)
	{
		chkname[1] = chkname[0] + i;
		if(player.name == chkname[1]) return true;
	}
	return false;
}

isUnknown(player)
{
	// Check if player has unacceptable name

	self endon("disconnect");
	self endon("ex_dead");
	
	if(isUnknownSoldier(player)) return true;
	if(isAssignedName(player)) return true;
	return false;
}

getFreeGuestSlot()
{
	// Get a free guest number.

	self endon("disconnect");
	self endon("ex_dead");

	chkname = [];
	maxguestno = getDvarInt("sv_maxclients");
	players = getentarray("player", "classname");
	maxplayers = players.size;

	if(level.ex_usclanguest) chkname[0] = level.ex_usclanguestname;
		else chkname[0] = level.ex_usguestname;

	i = 1;
	while(i <= maxguestno)
	{
		chkname[1] = chkname[0] + i;
		found = false;
		for(j = 0; j < maxplayers; j++)
		{
			if(players[j].name == chkname[1])
			{
				found = true;
				break;
			}
		}
		if(found) i++;
			else break;
	}
	return i;
}